PRO MESS_1D, ID, NGEN, MSTAR, DPC, XLIM, YLIM, A_RANGE, M_RANGE, DISTR, FULL=FULL, $
             R_STAR=R_STAR, L_STAR=L_STAR, T_STAR=T_STAR, A_STAR=A_STAR, MG_STAR=MG_STAR, $
             EFIX=EFIX, OFIX=OFIX, IFIX=IFIX, OBS_DATE=OBS_DATE, INSTR=INSTR, $
             MSCALE=MSCALE, NOPROB=NOPROB, NOSAVE=NOSAVE, NSEED=NSEED, PSEED=PSEED,$
             JDSTART=JDSTART, TIMESPAN=TIMESPAN, DIR=DIR, GENFILE=GENFILE, $
             PLANETFILE=PLANETFILE, PROBFILE=PROBFILE, BAND=BAND, $
             ACRIT_CB=ACRIT_CB, ACRIT_CS=ACRIT_CS, FXLIM=FXLIM, FYLIM_UP1=FYLIM_UP1, $
             FYLIM_UP2=FYLIM_UP2,FYLIM_LOW=FYLIM_LOW, ALB_VAL=ALB_VAL

;
; NAME: MESS_1D
; PURPOSE: 
; EXPLANATION:
; CALLING SEQUENCE: ID, DISTR, XLIM, YLIM, DIR=DIR, BAND=BAND, $
;             FXLIM=FXLIM, FYLIM_UP1=FYLIM_UP1, $
;             FYLIM_UP2=FYLIM_UP2,FYLIM_LOW=FYLIM_LOW

; INPUTS: 
;           ID - ID of the star 
;        DISTR - chosen distribution for the seed generation -  used
;                to define the name of the output files
;         XLIM - x axis for the detection limits (usually the
;                projected separation)
;         YLIM -  mass limit values 
; OPTIONAL INPUT KEYWORDS:
;          DIR - directory where the planet files must be placed, if
;                different from the working one
;         BAND - Band in which the observations are done. To be set if data
;                from the same star in different bands are available
;        FXLIM - x axis for the formation limits (usually the
;                semi-major axis)
;    FYLIM_UP1 - upper limit on the mass, from the formation models
;    FYLIM_UP2 - upper limit on the mass, from the formation models
;    FYLIM_LOW - lower limit on the mass, from the formation models
; EXAMPLES:
;
; RESTRICTIONS: This version of MESS_1D requires the mass limits to work.
;               Also, the xlim must be equal to the projected separation.
; PROCEDURES CALLED: RANDOM_FIX
; REVISION HISTORY:
;     Written:
;    Modified:




arange=a_range
mrange=m_range
IF keyword_set(NA_VAL) then na=NA_VAL
IF keyword_set(NM_VAL) then nm=NM_VAL

IF keyword_set(mscale) THEN m_val=m_val*(mstar[0]^mscale)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF DISTR EQ 'GRID' THEN BEGIN
na=nseed
nm=nseed
astep=round(((arange[1]-arange[0])/float(na))*10.)/10.
mstep=round(((mrange[1]-mrange[0])/float(nm))*10.)/10.
a_val=arange[0]+(indgen(na)*astep)
m_val=mrange[0]+(indgen(nm)*mstep)

IF keyword_set(ACRIT_CB) THEN BEGIN 
IF ACRIT_CB[0] NE 0 AND ACRIT_CB[0] GT ARANGE[0] THEN BEGIN
cb=where(a_val gt acrit_cb[0], ncb)
if ncb ne 0 then a_val=a_val(cb)
END ;IF ACRIT_CB
END ;IF SET ACRIT_CB
IF keyword_set(ACRIT_CS) THEN BEGIN
IF ACRIT_CS[0] NE 0 AND ACRIT_CS[0] LT ARANGE[1] THEN BEGIN
cs=where(a_val lt acrit_cs[0], ncs)
if ncs ne 0 then a_val=a_val(cs)
END ;IF ACRIT_CS
END ;IF SET ACRIT_CS

END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF DISTR NE 'GRID' THEN BEGIN
if keyword_set(PSEED) then goto, noseed
PSEED=strcompress(strjoin([ID[0], '_', DISTR,'_seed.idl']), /remove_all)
PLANETS_SEED, DISTR, NSEED, ARANGE, MRANGE, MSTAR[0], PSEED, ALPHA=ALPHA, BETA=BETA
noseed:
restore, PSEED
a_val=a
m_val=mass
IF keyword_set(ACRIT_CB) THEN BEGIN 
IF ACRIT_CB[0] NE 0 AND ACRIT_CB[0] GT ARANGE[0] THEN BEGIN
cb=where(a_val gt acrit_cb[0], ncb)
if ncb ne 0 then a_val=a_val(cb)
END ;IF ACRIT_CB
END ;IF SET ACRIT_CB
IF keyword_set(ACRIT_CS) THEN BEGIN
IF ACRIT_CS[0] NE 0 AND ACRIT_CS[0] LT ARANGE[1] THEN BEGIN
cs=where(a_val lt acrit_cs[0], ncs)
if ncs ne 0 then a_val=a_val(cs)
END ;IF ACRIT_CS
END ;IF SET ACRIT_CS

END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 outprob=strcompress(strjoin(['Prob_', distr, '_', ID,'_1D.fits']), /remove_all)
IF KEYWORD_SET(BAND) THEN outprob=strcompress(strjoin(['Prob_', ID, '_',BAND,'_1D.fits']), /remove_all)
IF KEYWORD_SET(PROBFILE) then outprob=probfile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
na=n_elements(a_val)
nm=n_elements(m_val)
det_prob=fltarr(na,nm)
form_prob=fltarr(na, nm)
outplanets=strarr(na, nm)
outgen=strarr(na,nm)

 FOR t=0, na-1 DO BEGIN
  a_fix=a_val(t)
  FOR tt=0, nm-1 DO BEGIN
   m_fix=m_val(tt)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    outplanets=strcompress(strjoin([ID, '_det_planets_SAM_1D_', distr, '_',$
;               string(a_fix,format='(f7.1)'), 'AU_', string(m_fix,format='(f5.1)'), $
;               'mjup.idl']), /remove_all)
 outplanets(t, tt)=strcompress(strjoin([ID, '_det_planets_SAM_1D_', distr, '_aval',$
               string(t), 'mval', string(tt), $
               '.idl']), /remove_all)

IF keyword_set(BAND) THEN outplanets(t, tt)=strcompress(strjoin([ID, 'det_planets_SAM_1D_', distr, '_aval',$
               string(t), '_mval', string(tt), '_',band, '.idl']), /remove_all)

IF keyword_set(DIR) then outplanets(t, tt)=strcompress(strjoin([DIR, outplanets(t, tt)]), /remove_all)
IF KEYWORD_SET(PLANETFILE) THEN outplanets(t,tt)=planetfile(t,tt)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
outgen(t,tt)=strcompress(strjoin([ID, '_gen_planets_SAM_1D_', distr, '_aval',$
               string(t), 'mval', string(tt), $
               '.idl']), /remove_all)

IF keyword_set(nosave) THEN  outgen(t,tt)='temp_gen_pl.idl'
IF keyword_set(DIR) then outgen(t,tt)=strcompress(strjoin([DIR, outgen(t,tt)]), /remove_all)

IF keyword_set(GENFILE) THEN BEGIN
outgen(t,tt)=genfile(t,tt)
print, 'skip random gen'
;print, genfile(t,tt)
goto, skip_random
END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RANDOM_FIX, MSTAR, DPC, A_FIX, M_FIX, NGEN, OUTGEN(t,tt), FULL=FULL, $
                 R_STAR=R_STAR, L_STAR=L_STAR, T_STAR=T_STAR, A_STAR=A_STAR, MG_STAR=MG_STAR, $
                 BAND=BAND, EFIX=EFIX, OFIX=OFIX, IFIX=IFIX, ALB_FIX=ALB_FIX, $
                 OBS_DATE=OBS_DATE, JDSTART=JDSTART, TIMESPAN=TIMESPAN


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF keyword_set(noprob) then goto, skip_prob1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
skip_random:
;print, outgen(t,tt)


restore, outgen(t,tt);, /verb

det_flag=FLTARR(ngen)
form_flag=FLTARR(ngen)


FOR i=0, ngen-1 DO BEGIN
det_flag(i)=0
form_flag(i)=0
fflag_low=0
fflag_up1=0
fflag_up2=0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF keyword_set(fylim_low) THEN BEGIN
form_flag[i]=0
fflag_low=0
if a[i] lt fxlim[0] then goto, exit
formlim_low=interpol(fylim_low, fxlim, a[i])
IF mass[i] lt formlim_low[0] then goto, exit 
IF mass[i] gt formlim_low[0] then fflag_low=1
IF fflag_low EQ 1 THEN form_flag[i]=1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF keyword_set(fylim_up1) THEN BEGIN
form_flag[i]=0
if a[i] lt fxlim[0] then goto, exit
formlim_up1=interpol(fylim_up1, fxlim, a[i])
IF mass[i] gt formlim_up1[0] then goto, exit 
IF mass[i] lt formlim_up1[0] then fflag_up1=1
IF fflag_low EQ 1 AND fflag_up1 EQ 1 THEN form_flag[i]=1
END ;IF fylim_up1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IF keyword_set(fylim_up2) THEN BEGIN
form_flag[i]=0
fflag_up2=0
if a[i] lt fxlim[0] then goto, exit
formlim_up2=interpol(fylim_up2, fxlim, a[i])
IF mass[i] gt formlim_up2[0] then goto, exit 
IF mass[i] lt formlim_up2[0] then fflag_up2=1
IF fflag_low EQ 1 AND fflag_up1 EQ 1 AND fflag_up2 EQ 1 THEN form_flag[i]=1
END ;IF fylim_up2
END ;IF fylim_low
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if instr ne 'RV' and rho_arcsec[i] lt xlim[0]/dpc[0] then goto, exit
;if rho_arcsec[i] gt xlim[0]/dpc[0] then goto, exit
if instr eq 'RV' and p[i] lt xlim[0] then goto, exit

if instr ne 'RV' then dmlim=interpol(ylim, xlim/dpc[0], rho_arcsec[i])
if instr eq 'RV' then dmlim=interpol(ylim, xlim, p[i])

IF INSTR EQ 'MDI' OR INSTR EQ 'RV' THEN BEGIN
IF mass[i] lt dmlim then goto, exit
IF mass[i] gt dmlim then det_flag[i]=1
END

IF INSTR EQ 'DI' THEN BEGIN
det_flag[i]=0
DeltaMag=2.5*alog10(pla_cnt[i])
IF DeltaMag GE dmlim THEN goto, exit
IF DeltaMag LT dmlim THEN det_flag[i]=1
END

exit:
END                              ;FOR i=0, ngen-1



nf=where(form_flag ne 0, nform)
IF keyword_set(fxlim) THEN form_prob(t,tt)=float(nform)/float(ngen)
IF keyword_set(fxlim) EQ 0 THEN nform=ngen

nd=where(det_flag ne 0, ndet)
if ndet ne 0 then det_prob(t,tt)=float(ndet)/float(nform)

;print, a_fix, m_fix,  det_prob(t,tt)



save, form_flag, det_flag,mass, a, p, e, rho_arcsec, x_arcsec,y_arcsec, filename=outplanets(t,tt)
IF keyword_set(FULL) THEN  save, form_flag, det_flag,mass, a, p, e, $
                           rho_arcsec, x_arcsec,y_arcsec, t0, obstime, $
                           omega_peri_rad, irad, omega_node_rad, frac_ill, $
                           pla_rad, pla_teff, pla_cnt, kappa_rv, ampl_astrom, $
                           TR_pb, TR_dp, pla_alb, filename=outplanets(t,tt)

IF INSTR eq 'MDI' THEN BEGIN
tek_color
ma=max(a_val)
mm=max(m_val)
plot, xlim, ylim, title=ID
IF keyword_set(fylim_up1) THEN oplot, fxlim, fylim_up1, col=2
IF keyword_set(fylim_up2) THEN oplot, fxlim, fylim_up2, col=2
IF keyword_set(fylim_low) THEN oplot, fxlim, fylim_low, col=2


oplot, a, mass, psym=2, symsize=0.5
 
IF keyword_set(fxlim) AND nform NE 0 THEN oplot, a(nf), mass(nf), psym=2, symsize=0.5, col=2
IF  ndet NE 0 THEN oplot, a(nd), mass(nd), psym=2, symsize=0.3, col=3
END ;IF INSTR eq 'MDI'
skip_prob1:
END ; FOR tt=1, nm-1 
END ; FOR t=1, na-1 

if keyword_set(NOPROB) then goto, skip_prob2
  
writefits, outprob, det_prob
skip_prob2:
END
